//$Id: InterfaceSimulation.java 1.1 2004/11/27 15:26:03 Florent Exp Florent $
package sims;


/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */

/**
 * Interface que doit respecter une simulation d'une machine
 *
 * @author florent.kaisser@free.fr
 * @version $Id: InterfaceSimulation.java 1.1 2004/11/27 15:26:03 Florent Exp Florent $
 *
 * $Log: InterfaceSimulation.java $
 * Revision 1.1  2004/11/27 15:26:03  Florent
 * Initial revision
 *
 */
public interface InterfaceSimulation {
    public static final int[] VITESSES = { 0, 1000, 700, 400, 100, 0 };

    abstract void demarrer();

    abstract void arreter();

    abstract void reinitialiser();

    abstract void prochainPas();

    abstract void incVitesse();

    abstract void decVitesse();

    abstract int getVitesse();

    abstract String getNom();
}
