/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
/**
 * class starting the application by creating an instance of MainWindow. Also set the LAF at Metal.
 *
*  @author JP <jpnossa@free.fr>
*  @version 20/11/04
 */
package sims;

import sims.ihm.*;

import sims.mdt.*;

import java.io.*;

import javax.swing.*;


public class SimStart implements GraphicValues {
    public static final String metalLaf = "javax.swing.plaf.metal.MetalLookAndFeel";
    public static final String motifLaf = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";

    public static void main(String[] args) throws IOException {
        /* for fully decorated windows */

        //JFrame.setDefaultLookAndFeelDecorated(true);
        //JDialog.setDefaultLookAndFeelDecorated(true);
        if (args.length == 0) {
            args = new String[1];
            args[0] = " ";
        }

        MainWindow w = new MainWindow(args[0]);

        try {
            UIManager.setLookAndFeel(METAL_LAF);
            SwingUtilities.updateComponentTreeUI(w);
        } catch (Exception e) {
        }
    }
}
