/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
/**
* "A propos de..." window
*
* @author jp <jpnossa@free.fr>
* @version 20/12/04
*
*/
package sims.ihm;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;

import java.io.*;

import javax.swing.*;
import javax.swing.event.*;


public class CreditWindow extends JFrame implements GraphicValues {
    private static final String title = "About...";
    private static final String l1 = "SIMS ( Sims Is a Machine Simulator ) - Version 0.1";
    private static final String l2 = "Simulator, visualisator and editor of Turing machines";
    private static final String l3 = "and register machines.";
    private static final String l4 = "Computer science maitrise project - 2004/2005";
    private static final String l5 = "Cergy-Pontoise university, 95, France";
    private static final String jp = "Jean-Philippe Aumasson <jpnossa@free.fr>";
    private static final String jb = "Jean-Baptiste Langlois <jean-baptiste.langlois@wanadoo.fr>";
    private static final String flo = "Florent Kaisser <florent.kaisser@free.fr>";
    private static final String san = "Sandrine Phcar <sandrine_phcar@hotmail.com>";
    private JButton ok;

    ////////////////////////////////////////////////////////////////////
    public CreditWindow() {
        super();
        setTitle(title);
        setSize(CRED_WIDTH, CRED_HEIGHT);
        setResizable(false);

        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        setLocation((dim.width / 2) - (getWidth() / 2),
            (dim.height / 2) - (getHeight() / 2));

        WindowListener l = new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    setVisible(false);
                    dispose();
                }
            };

        addWindowListener(l);

        Background back = new Background();

        getContentPane().add(back);
        setVisible(true);
    }

    ////////////////////////////////////////////////////////////////////
    private void quit() {
        setVisible(false);
        dispose();

        try {
            finalize();
        } catch (Throwable t) {
        }
    }

    ////////////////////////////////////////////////////////////////////
    class Background extends JPanel {
        private Image image;

        public Background() {
            image = Toolkit.getDefaultToolkit().getImage("sims/ihm/visuals/credits.jpg");

            MediaTracker tracker = new MediaTracker(this);
            tracker.addImage(image, 0);

            try {
                tracker.waitForID(0);
            } catch (InterruptedException exception) {
            }
        }

        public void paintComponent(Graphics gr) {
            super.paintComponent(gr);

            Graphics2D g = (Graphics2D) gr;
            g.drawImage(image, 0, 0, null);
            setBackground(Color.WHITE);
            g.setFont(CRS);
            g.drawString(l1, 10, 30);
            g.drawLine(10, 40, 350, 40);
            g.setFont(POLIZEI);
            g.drawString(l2, 10, 60);
            g.drawString(l3, 10, 80);
            g.drawLine(10, 100, 350, 100);
            g.setFont(CRS);
            g.drawString(l4, 10, 120);
            g.drawString(l5, 10, 140);
            g.setFont(POLIZEI);
            g.drawString(jp, 10, 160);
            g.drawString(flo, 10, 180);
            g.drawString(jb, 10, 200);
            g.drawString(san, 10, 220);
        }
    }

    ////////////////////////////////////////////////////////////////////
}
