/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
/**
* interface containing all graphic size values...may be modified so as to fit to the screen size...
* ( Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
* setLocation(dim.width/2 - getWidth()/2, dim.height/2 - getHeight()/2); =
*  @author JP <jpnossa@free.fr>
*  @version 20/12/04
* */
package sims.ihm;

import java.awt.*;


public interface GraphicValues {
    public static final int TAPE_SIZE = 200;
    public static final int CELL_SIZE = 16;
    public static final int TAPES_SPACE = 50;
    public static final int VIEW_WIDTH = 800;
    public static final int VIEW_HEIGHT = 250;
    public static final int LAST_CELL = Math.abs(VIEW_WIDTH / CELL_SIZE) - 3; // the righmost cell we can scann on the viewer
    public static final int COMMANDS_WIDTH = 346;
    public static final int COMMANDS_HEIGHT = 68;
    public static final int CMD_BUTTON_WIDTH = 32;
    public static final int CMD_BUTTON_HEIGHT = 32;
    public static final int MAIN_WIDTH = 600;
    public static final int MAIN_HEIGHT = 440;
    public static final int HELP_WIDTH = 800;
    public static final int HELP_HEIGHT = 600;
    public static final int TUPDT_WIDTH = 400;
    public static final int TUPDT_HEIGHT = 100;
    public static final int TMODIF_WIDTH = 400;
    public static final int TMODIF_HEIGH = 100;
    public static final int EDIT_X = 5;
    public static final int EDIT_Y = 5;
    public static final int EDIT_WIDTH = 450;
    public static final int EDIT_HEIGHT = 500;
    public static final int MESS_WIDTH = 450;
    public static final int MESS_HEIGHT = 75;
    public static final int CRED_WIDTH = 401;
    public static final int CRED_HEIGHT = 267;
    public static final int GRAPH_WIDTH = 560;
    public static final int GRAPH_HEIGHT = 500;
    public static final int TAILLE_BARRE_TACHE = 32;
    public static final Font POLICE = new Font("SansSerif", Font.PLAIN, 12);
    public static final Font CRS = new Font("SansSerif", Font.BOLD, 11);
    public static final Font POLIZEI = new Font("SansSerif", Font.PLAIN, 11);
    public static final String METAL_LAF = "javax.swing.plaf.metal.MetalLookAndFeel";
    public static final String MOTIF_LAF = "javax.swing.plaf.motif.MotifLookAndFeel";
}
