package sims.ihm.graph;


/**
* implementation de la notion de file d'entier
*/
public class FileA extends Object {
    private int nbElement; /* nombre de cellules ds la file */
    private Cellule premier; /* tete de file */
    private Cellule dernier; /* dernier element insere ds la file */

    /* Generateurs de base */

    /** Construit une File chainee d'entier vide
     */
    public FileA() {
        nbElement = 0;
        premier = null;
        dernier = null;
    }

    /** Enfile un entier dans la file
     */
    public void enfiler(int nb) {
        /* Creation de la nouvelle cellule */
        Cellule cell = new Cellule(nb);

        if (dernier == null) {
            /* la file est vide */
            premier = cell;
        } else {
            dernier.suivant = cell;
        }

        dernier = cell;

        nbElement++;
    }

    /* autres operateurs */

    /** supprime l'element de tete de la file
     *  precondition : la file est non vide
     */
    public void defiler() {
        premier = premier.suivant;
        nbElement--;

        /* teste si la file est vide */
        if (nbElement == 0) {
            dernier = null;
        }
    }

    /* Observateurs */

    /** teste la vacuité de la file
     */
    public boolean estVide() {
        return (nbElement == 0);
    }

    /** retourne le nombre d'element de la file
     */
    public int longueur() {
        return nbElement;
    }

    /** retourne la valeur de l'ement en tete de la file
     *  precondition : la file est non vide
     */
    public int tete() {
        return premier.valeur;
    }
}
