package sims.ihm.graph;


/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
import sims.*;

import sims.ihm.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;

import java.io.*;

import java.util.*;

import javax.swing.*;
import javax.swing.event.*;


public class JGraph2D extends JFrame implements GraphicValues {
    private String fileName;
    private Graph g1;
    private Vector states;
    private GrapheInterface m;
    private Object EtatCourant;

    public JGraph2D(GrapheInterface mm) {
        //setTitle(title);
        //fileName = title;

        m = mm;
        
        if(m!=null)
        	EtatCourant = m.getRacine();

        setSize(GRAPH_WIDTH, GRAPH_HEIGHT);

        DrawPanel Screen = new DrawPanel();
        Container contentPane = getContentPane();
        contentPane.add(Screen);
    }

    public void setEtatCourant(Object o) {
        EtatCourant = o;
        repaint();
    }

    public Object getCurrentState() {
        return EtatCourant;
    }

      public void setMachine(GrapheInterface mach) {
        m = mach;
        if(m!=null)
        	EtatCourant = m.getRacine();
    }

    public class DrawPanel extends JPanel {
        public void paintComponent(Graphics g) {
            super.paintComponent(g);

            if (m != null) {
                Graphics2D g2 = (Graphics2D) g;

                /* Quand on reset on recharge la machine, l'adresse de m a donc chang..*/
                /* m reste l'adresse de l'ancienne donc l'tat courant reste le dernier...*/
                int N = m.getNbrEtat();

                g1 = new Graph(g2, m, N, getBounds().width, getBounds().height);
                g1.currentState(EtatCourant);
                g1.Placement();

                //System.out.println(g1.crossing());
                //g1.Ameliorer();
                g1.setCoordinates();

                //for(int i=0;i<N;i++) System.out.println(g1.getState(i).getSelfSucc());
                g1.draw();
            }
        }
    }
}
