package sims.ihm.graph;


/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
class Order {
    private Graph g;
    private Rank r;

    //private int[] ordr;
    public Order(Graph i, Rank j) {
        g = i;
        r = j;
    }

    public void initOrder(int i, float n) {
        if (g.getState(i).getOrder() == 0) {
            g.getState(i).setOrder(n++);

            if (g.getState(i).getOutEdge() != 0) {
                for (int j = 0; j < g.getState(i).getOutEdge(); j++)
                    initOrder(g.getState(i).getSucc(j), n);
            }
        }
    }

    public float maximumOrder() {
        float i = g.getState(0).getOrder();

        for (int j = 0; j < g.nbStates; j++)
            if (g.getState(j).getOrder() > i) {
                i = g.getState(j).getOrder();
            }

        return i;
    }

    public float minimumOrder() {
        float i = g.getState(0).getOrder();

        for (int j = 0; j < g.nbStates; j++)
            if (g.getState(j).getOrder() < i) {
                i = g.getState(j).getOrder();
            }

        return i;
    }

    public void normalize() {
        float i = minimumOrder();

        for (int j = 0; j < g.nbStates; j++)
            g.getState(j).setOrder(g.getState(j).getOrder() - minimumOrder());
    }
}
