/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
//$Id: ActionMAR.java 1.1 2004/11/27 15:30:19 Florent Exp Florent $
package sims.mar;


/**
 * @author florent.kaisser@free.fr
 * @version $Id: ActionMAR.java 1.1 2004/11/27 15:30:19 Florent Exp Florent $
 *
 * Classe pour notifier l'xecution d'une instruction
 *
 * $Log: ActionMAR.java $
 * Revision 1.1  2004/11/27 15:30:19  Florent
 * Initial revision
 *
 */
public interface ActionMAR {
    /**
     * methode appel quand l'intruction est execut
     * @param i Instruction excut
     * @param o Objet associ avec cette action
    */
    abstract void instructionExecute(Instruction i);

    /**
     * appel quand le programme  termin son excution (arrive sur le sommet fin)
     *
     */
    abstract void programmeFin();

    /**
     * appel quand le programme commence son excution (sommet debut)
     *
     */
    abstract void programmeDebut();

    /**
     * appel quand le programme arrive sur un etat, marqu par un point d'arret
     *
     */
    abstract void programmeBreakPoint();

    /**
     * appel quand la vitesse d'execution du programme est chang
     * @param vitesse vitesse actuelle du programme
     */
    abstract void vitesseChange(int vitesse);
}
