/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
//$Id: ParseFileMAR.java 1.5 2004/11/27 15:30:19 Florent Exp Florent $
package sims.mar;

import java.io.*;

import java.util.*;


/**
 *
 * Lis un fichier MAR qui permet de charger un programme
 *
 * @author florent.kaisser@free.fr
 * @version $Id: ParseFileMAR.java 1.5 2004/11/27 15:30:19 Florent Exp Florent $
 *
 * $Log: ParseFileMAR.java $
 * Revision 1.5  2004/11/27 15:30:19  Florent
 * ligne commence  0
 * verification que chaque instruction est associ  une commande
 * Bug : un label ne peut pas commencer par un chiffre
 *
 * Revision 1.4  2004/11/01 20:56:04  Florent
 * gestion des commentaires
 * finition des directives
 *
 */

/*
 *
 *
 */
public class ParseFileMAR {
    private int c;
    private Programme prog;
    private Instruction instructionFin;
    private Fin fin;
    private Debut debut;
    private FileInputStream f;
    private Hashtable instructions = new Hashtable();
    private int ligne = 1;

    ParseFileMAR(FileInputStream f) throws IOException {
        this.f = f;

        //c_suiv();
    }

    /*private Registre AjouterRegistrePlus(int id,int val){
            Registre r=new RegistrePlus(prog,id,val);

            if(prog.registrePlus.size()<id)prog.registrePlus.setSize(id);
            prog.registrePlus.set(id-1,r);

            return r;
    }

    private Registre AjouterRegistreMoins(int id,int val){
            Registre r=new RegistreMoins(prog,id,val);

            if(prog.registreMoins.size()<id)prog.registreMoins.setSize(id);
            prog.registreMoins.set(id-1,r);

            return r;
    }

    private void AjouterFin(){
            fin=new Fin(prog);
            instructionFin=createInstruction("FIN",fin);
    }

    private void AjouterDebut(){
            debut=new Debut(prog);
    }

    private void erreur() throws IOException{
            throw new IOException("Erreur de syntaxe  la ligne "+ ligne);
    }

    private int N() throws IOException{
            String entier="";
            while(c>='0' && c<='9' ){
                    entier+=((char)c);
                    c_suiv();
            }
            return Integer.parseInt(entier);
    }


    private Registre R() throws IOException{
            switch  (c){
             case 'R':
                     c_suiv();
                    int num=N();
                    switch (c){
                            case '+':c_suiv();return (Registre)prog.registrePlus.get(num-1);
                            case '-':c_suiv();return (Registre)prog.registreMoins.get(num-1);
                            default: erreur();
                    }


             default:
                     erreur();
            }
            return null;
    }

    private void E() throws IOException{
            while(c==' ' || c=='\t' || c=='\r' || c=='\n')c_suiv();
    }

    private void LireInitRegistre() throws IOException{
            while(c!='\r' && c!='\n'){
                    int val=0;
                    if(c!='R')erreur();c_suiv();
                    int num=N();
                    int type=c;
                    c_suiv();
                    if(c=='='){
                            c_suiv();
                            val=N();
                    }

                    switch (type){
                            case '+':
                                    AjouterRegistrePlus(num,val);
                                    break;
                            case '-':
                                    AjouterRegistreMoins(num,val);
                                    break;
                            default: erreur();
                    }
                    if(c!=';') erreur();
                    c_suiv();
            }
    }

    private String lireIndentificateur() throws IOException{
            String id=new String();

            while((c>='A' && c<='Z') || (c>='a' && c<='z') || (c>='0' && c<='9')){
                    id+=((char)c);
                    c_suiv();
            }

            return id;
    }

    private Instruction createInstruction(String id,Commande cmd){
            Instruction instruction=new Instruction(prog,cmd);
            instructions.put(id,instruction);
            prog.ajouterSommet(instruction);
            return instruction;
    }

    private Instruction getInstruction(String id,Commande cmd)throws IOException{
            Instruction instruction=(Instruction)instructions.get(id);
            if(instruction==null)
                    instruction=createInstruction(id,cmd);
            if(cmd!=null)
                    instruction.setCommande(cmd);
                    //throw new IOException("Identificateur introuvable  la ligne " + ligne);
            return instruction;
    }

    private Instruction getInstruction(String id)throws IOException{
            return getInstruction(id,null);
    }

    private void S() throws IOException{
            Commande cmd;
            String id;
            Instruction inst;
            Instruction instSucc;
            E();
            id=lireIndentificateur();
            E();
            if(c!='(') erreur();c_suiv();
            inst=getInstruction(id,(id.compareTo("DEBUT")==0)?debut:(Commande)R());
            E();
            if(c!=')') erreur();c_suiv();
            E();
            if(c!='[') erreur();c_suiv();
            E();
            id=lireIndentificateur();
            E();
            if(c!=';') erreur();c_suiv();
            instSucc=getInstruction(id);
            E();
            prog.ajouterArete(new Arete(1,inst,instSucc));
            E();
            if(c=='0')
            {
                    c_suiv();
                    if(c!=':') erreur();c_suiv();

                    E();
                    id=lireIndentificateur();
                    E();
                    if(c!=';') erreur();c_suiv();
                    instSucc=getInstruction(id);
                    E();
                    prog.ajouterArete(new Arete(0,inst,instSucc));
                    E();
            }
            if(c!=']') erreur();c_suiv();
            E();
            if(c!=-1)
                    S();
    }

    private void readCaractere() throws IOException{
            if(c=='\n')ligne++;
            c=f.read();
    }

    private void c_suiv() throws IOException{
            boolean inComment=false;
            do{
                    readCaractere();
                    if(c=='#'){
                            if(inComment)readCaractere();
                            inComment=!inComment;
                    }
            }while(inComment);
    }
    */
    public Programme parse() throws IOException {
        prog = new Programme();

        /*AjouterDebut();
        AjouterFin();
        LireInitRegistre();
        S();*/
        return prog;
    }
}
