/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
//$Id: RegistreMoins.java 1.6 2004/11/27 15:30:19 Florent Exp Florent $
package sims.mar;


/**
 *
 * Commande R-
 *
 * @author florent.kaisser@free.fr
 * @version $Id: RegistreMoins.java 1.6 2004/11/27 15:30:19 Florent Exp Florent $
 *
 * $Log: RegistreMoins.java $
 * Revision 1.6  2004/11/27 15:30:19  Florent
 * Aucune modification
 *
 * Revision 1.5  2004/11/02 18:01:12  Florent
 * Ajout de commentaires
 *
 * Revision 1.4  2004/11/01 20:56:04  Florent
 * ajout de commentaire d'en-tete javadoc
 *
 */
public class RegistreMoins extends CommandeRegistre {
    /**
     *
     * @param registre registre  associer  la commande
     */
    RegistreMoins(Registre registre) {
        super(registre, "R" + registre.getIndice() + "-");
    }

    /* {src_lang=Java}*/

    /**
     * Execute la commande Ri-
     * Decremente le registre associ de 1
     * @return 1 si la dcrementation est efectu, 0 sinon (registre  0)
     */
    public int executer() {
        return myRegistre.dec();
    }
}
