/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
/**
 * an alphabet for Turing Machine, and for a tape.
 *
*  @author JP <jpnossa@free.fr>
*  @version 20/12/04
 */
package sims.mdt;

import java.util.*;


public class Alphabet extends Vector {
    public Alphabet() {
        super();
    }

    ////////////////////////////////////////////////////////////////////

    /**
    * Add a letter to this alphabet.
    * @param i the index where to add the letter.
    * @param c the letter to add to the alphabet
    */
    public void addLetter(int i, char c) {
        if (!contains(new Character(c))) {
            add(new Character(c));
        }
    }

    ////////////////////////////////////////////////////////////////////

    /**
    * To get a letter from an index in the alphabet.
    * @param i the index we want to get the letter.
    * @return a <tt>Character</tt> instance of the letter found.
    */
    public Character getLetter(int i) {
        if (i < size()) {
            return (Character) get(i);
        }

        return null;
    }
}
