/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
/**
 * class to manage exception and errors
 *
*  @author JP <jpnossa@free.fr>
*  @version 20/12/04
 */
package sims.mdt;

import sims.ihm.*;


public class TuringException extends Exception {
    public TuringException(String mess) {
        new ErrorBox(mess);
    }

    // parsing errors, with line number
    public TuringException(String mess, int ligne) {
        new ErrorBox(mess, ligne);
    }

    public static void error(String mess) {
        new ErrorBox(mess);
    }

    // parsing erros, with line number
    public static void error(String mess, int ligne) {
        new ErrorBox(mess, ligne);
    }
}
