/*
 * Copyright 2005 Jean-Philippe Aumasson <jpnossa@free.fr>
 * Copyright 2005 Florent Kaisser <jpnossa@free.fr>
 * Copyright 2005 Jean-Baptiste Langlois <florent.kaisser@free.fr>
 *
 * This file is part of SIMS : SIMS Is a Machine Simulator
 *
 * SIMS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SIMS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SIMS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * For more details see the file COPYING.
 */
/**
* A Nondeterministic machine, created when ND machine read, link betw fifo and the mach itself
*
*  @author JP <jpnossa@free.fr>
*  @version 20/12/04
*/
package sims.mdt.nd;

import sims.mdt.*;

import java.util.*;


public class NDMachine {
    private MachineRead m; // the associated MachineRead, bidirectionnal relation
    private Fifo fi; // the associated fifo of the D2ND simulation

    ////////////////////////////////////////////////////////////////////
    public NDMachine(MachineRead m) {
        this.m = m;
        fi = new Fifo(m.currentConf());
    }

    ////////////////////////////////////////////////////////////////////

    /**
    * Load the m-config on top of the Fifo in m
    *
    */
    public MConfig loadConfig() {
        return fi.getFirst();
    }

    ////////////////////////////////////////////////////////////////////

    /**
    * Enqueue the config c into the Fifo
    *
    */
    public void enqueueConfig(MConfig c) {
        fi.add(c);
    }
}
